Index: bot/trunk/Makefile.PL
===================================================================
--- bot/trunk/Makefile.PL	(revision 401)
+++ bot/trunk/Makefile.PL	(revision 405)
@@ -4,5 +4,5 @@
 # the contents of the Makefile that is written.
 WriteMakefile(
-    NAME              => 'Sophie::Tools',
+    NAME              => 'Sophie::Bot',
     VERSION_FROM      => 'lib/Sophie/Bot.pm', # finds $VERSION
     PREREQ_PM         => {}, # e.g., Module::Name => 1.1
@@ -12,5 +12,4 @@
     EXE_FILES => [ qw(
         bin/sophie-bot
-        bin/sophie-rpm
     ) ],
     macro => {
@@ -34,8 +33,8 @@
 \tsvn log > ChangeLog
 
-sophie-tools.spec: sophie-tools.spec.in Makefile
+sophie-bot.spec: sophie-bot.spec.in Makefile
 \tsed -e 's/\@VERSION@/\$(VERSION)/' < \$< > \$@
 
-rpm: \$(DISTVNAME).tar.gz sophie-tools.spec
+rpm: \$(DISTVNAME).tar.gz sophie-bot.spec
 \tmkdir ./noarch || :
 \trpmbuild -ba --clean\\
@@ -44,7 +43,7 @@
 \t --define "_srcrpmdir \$(DESTRPMDIR)" \\
 \t --define "_rpmdir \$(DESTRPMDIR)" \\
-\t sophie-tools.spec
+\t sophie-bot.spec
 
-svnrpm: \$(DISTVNAME).tar.gz sophie-tools.spec
+svnrpm: \$(DISTVNAME).tar.gz sophie-bot.spec
 \tmkdir \$(DESTRPMDIR)/noarch || :
 \trpmbuild -ba --clean\\
@@ -54,5 +53,5 @@
 \t --define "_rpmdir \$(DESTRPMDIR)" \\
 \t --define "svnrelease `LC_ALL=C svn info | grep '^Revision:' | sed 's/Revision: //'`" \\
-\t sophie-tools.spec
+\t sophie-bot.spec
 
 EOF
Index: bot/trunk/bin/sophie-rpm
===================================================================
--- bot/trunk/bin/sophie-rpm	(revision 401)
+++ 	(revision )
@@ -1,138 +1,0 @@
-#! /bin/env perl
-
-use strict;
-use warnings;
-use Sophie::Client;
-use Getopt::Long;
-use Pod::Usage;
-use Config::General;
-use File::Temp;
-
-my $distrib = {};
-
-GetOptions(
-    'c=s' => \my $configfile,
-    'u=s' => \my $url,
-    'l=s' => \my $login,
-    'p=s' => \my $pass,
-    't=s' => \my $type,
-    'd=s' => \my @options,
-    'proxy' => \my $proxy,
-
-) or pod2usage;
-
-my %options;
-foreach (@options) {
-    m/([^=]+)\s*=\s*(.*)/ or next;
-    $options{$1} = $2;
-}
-
-$configfile ||= "$ENV{HOME}/.sophie.conf";
-
-if (-f $configfile && (my $conf = Config::General->new($configfile))) {
-    my %config = $conf->getall;
-    $url         ||= $config{url};
-    $login       ||= $config{login};
-    $pass        ||= $config{pass};
-    $proxy       ||= $config{proxy};
-    $distrib     = $config{distrib};
-}
-
-my $sc = Sophie::Client->new(
-    server => $url,
-    login => $login,
-    password => $pass,
-    type => $type,
-    proxy => $proxy,
-);
-
-$sc->login;
-
-my %rpmid;
-foreach my $rpm (@ARGV) {
-    my $string = `rpm -qp --qf '[%{*:xml}\n]' $rpm`;
-    warn "Loarding $rpm\n";
-
-    my $res = $sc->send_request('user.folder.load_rpm', $string);
-    if (ref $res && ! $res->is_fault) {
-        $rpmid{$res->value} = $rpm;
-    } else {
-        die((ref $res ? $res->string : $res) . "\n");
-    }
-}
-
-my %pool;
-{
-    foreach (@{ $sc->send_request('user.folder.list')->value }) {
-        $pool{$_->{id}} = $_->{name} . '-' . $_->{evr}; 
-    }
-}
-
-my @unresolved;
-foreach my $rpmid (keys %rpmid) {
-    warn "Analysing $rpmid{$rpmid}\n";
-    my $analyse = $sc->send_request('analysis.find_requirements',
-        $distrib,
-        $rpmid,
-        [ keys %rpmid ],
-    );
-    if (ref $analyse && !$analyse->is_fault) {
-        my $result = $analyse->value;
-        print "\nPackage requirements\n";
-        foreach my $dep (keys %{ $result->{bydep} }) {
-            print $dep . ":\n";
-            foreach (@{ $result->{bydep}{$dep}{pkg} || []}) {
-                print "    " . $sc->send_request('rpms.basicinfo', $_)->value->{filename};
-                print "\n";
-            }
-            foreach (@{ $result->{bydep}{$dep}{pool} || [] }) {
-                print "  * " . $pool{$_} . "\n";
-            }
-        }
-        if (@{ $result->{unresolved} || []}) {
-            push(@unresolved, @{ $result->{unresolved} });
-            print "\nAre unresolved:\n";
-            print  map { " $_\n" }  @{ $result->{unresolved} };
-        }
-    }
-    my $diranalyse = $sc->send_request('analysis.parentdir',
-        $distrib,
-        $rpmid,
-        [ keys %rpmid ],
-    );
-    if (ref $diranalyse && !$diranalyse->is_fault) {
-        my $result = $diranalyse->value;
-        print "\nParent directories:\n";
-        foreach my $dir (sort keys %{ $result->{bydir} }) {
-            print $dir . ":\n";
-            if (@{ $result->{bydir}{$dir}{pkg} || []} > 3) {
-                print "    " . scalar(@{ $result->{bydir}{$dir}{pkg} || []}) .
-                " results in the distribution...\n";
-            } else {
-                foreach (@{ $result->{bydir}{$dir}{pkg} || []}) {
-                    print "    " . $sc->send_request('rpms.basicinfo', $_)->value->{filename};
-                    print "\n";
-                }
-            }
-            foreach (@{ $result->{bydir}{$dir}{pool} || [] }) {
-                print "  * " . $pool{$_} . "\n";
-            }
-        }
-        if (@{ $result->{notfound} || []}) {
-            print "\nUnowned directories:\n";
-            print  map { " $_\n" }  @{ $result->{notfound} };
-        }
-    }
-    print "\n";
-}
-
-$sc->send_request('user.folder.clear');
-
-if (@unresolved) {
-    print "Error, unresolved:\n";
-    print  map { " $_\n" }  @unresolved;
-    exit(1);
-} else {
-    exit(0);
-}
-
Index: bot/trunk/sophie-bot.spec.in
===================================================================
--- bot/trunk/sophie-bot.spec.in	(revision 405)
+++ bot/trunk/sophie-bot.spec.in	(revision 405)
@@ -0,0 +1,49 @@
+# $Id$
+
+%define realname   Sophie-Bot
+%define version    @VERSION@
+%define release    %mkrel %{?svnrelease:0.%{svnrelease}}%{?!svnrelease:1}
+
+Name:       sophie-bot
+Version:    %{version}
+Release:    %{release}
+License:    GPL or Artistic
+Group:      Development/Perl
+Summary:    Sophie's tools
+Source:     %{realname}-%{version}.tar.gz
+Url:        http://search.cpan.org/dist/%{realname}
+BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-buildroot
+BuildArch:  noarch
+BuildRequires: perl(RPC::XML)
+
+Requires: perl-Term-ReadLine-Gnu
+Requires: perl(Config::General)
+Requires: perl(POE::Component::IRC)
+
+%description
+Command line tools to query Sophie website (http://sophie.zarb.org/)
+
+%prep
+%setup -q -n %{realname}-%{version} 
+
+%build
+%{__perl} Makefile.PL INSTALLDIRS=vendor
+%make
+
+%check
+make test
+
+%install
+rm -rf %buildroot
+%makeinstall_std
+
+%clean
+rm -rf %buildroot
+
+%files
+%defattr(-,root,root)
+%doc Changes README
+%_bindir/*
+%{_mandir}/*/*
+%perl_vendorlib/*
+
Index: bot/trunk/sophie-tools.spec.in
===================================================================
--- bot/trunk/sophie-tools.spec.in	(revision 401)
+++ 	(revision )
@@ -1,49 +1,0 @@
-# $Id$
-
-%define realname   Sophie-Tools
-%define version    @VERSION@
-%define release    %mkrel %{?svnrelease:0.%{svnrelease}}%{?!svnrelease:1}
-
-Name:       sophie-tools
-Version:    %{version}
-Release:    %{release}
-License:    GPL or Artistic
-Group:      Development/Perl
-Summary:    Sophie's tools
-Source:     %{realname}-%{version}.tar.gz
-Url:        http://search.cpan.org/dist/%{realname}
-BuildRoot:  %{_tmppath}/%{name}-%{version}-%{release}-buildroot
-BuildArch:  noarch
-BuildRequires: perl(RPC::XML)
-
-Requires: perl-Term-ReadLine-Gnu
-Requires: perl(Config::General)
-Requires: perl(POE::Component::IRC)
-
-%description
-Command line tools to query Sophie website (http://sophie.zarb.org/)
-
-%prep
-%setup -q -n %{realname}-%{version} 
-
-%build
-%{__perl} Makefile.PL INSTALLDIRS=vendor
-%make
-
-%check
-make test
-
-%install
-rm -rf %buildroot
-%makeinstall_std
-
-%clean
-rm -rf %buildroot
-
-%files
-%defattr(-,root,root)
-%doc Changes README
-%_bindir/*
-%{_mandir}/*/*
-%perl_vendorlib/*
-